/*
 * InsertDef.java
 *
 * Created on 23  2002 ., 22:38
 */

package com.fn.dbgen;


import java.util.Iterator;
import java.util.HashMap;
import java.util.Map;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


/**
 *
 * @author  asso
 */
public class InsertDef {

    private String insertRule;
    private boolean quotes;
    
    /** Creates a new instance of InsertDef */
    public InsertDef(Element element) throws DgException {
        insertRule = XMLUtils.getTrimmedData(element);
        quotes = XMLUtils.getTagAttrib(element, "quotes", true);
    }

    
    private Map buildValuesMap(Element record) throws DgException {
        Map map = new HashMap();
        NodeList nodeList = record.getChildNodes();
        int len = nodeList.getLength();
        for (int i = 0; i < len; i++) {
            Node node = nodeList.item(i);
            switch (node.getNodeType()) {
                case Node.ELEMENT_NODE:
                    Element e = (Element)node;
                    map.put(e.getTagName(), XMLUtils.getTrimmedData(e));
                    break;            
                case Node.TEXT_NODE:
                    if (XMLUtils.isBlankText(node.getNodeValue()))
                        break;                    
                default:
                    throw new DgException("Error in database file: unexpected element");
            }
        }
        return map;
    }
           
    
    public String generateInsert(Element record, String tableName) throws DgException {
        Map args = new HashMap();
        args.put("t", tableName);
        
        Map values = buildValuesMap(record);
        
        boolean firstVal = true;
        StringBuffer sb = new StringBuffer();
        for (Iterator i = values.keySet().iterator(); i.hasNext(); ) {
            String name = (String)i.next();
            if (! firstVal)
                sb.append(", ");
            else
                firstVal = false;
            if (quotes)
                sb.append('"');
            sb.append(name);
            if (quotes)
                sb.append('"');
        }
        args.put("f", sb.toString());
        
        sb = new StringBuffer();
        firstVal = true;
        for (Iterator i = values.keySet().iterator(); i.hasNext(); ) {
            String name = (String)i.next();
            if (! firstVal)
                sb.append(", ");
            else
                firstVal = false;
            sb.append(values.get(name));
        }
        args.put("v", sb.toString());

        return Macros.processMacroses(insertRule, record, args);
    }
}
