/*
 * Macros.java
 *
 * Created on 22  2002 ., 16:26
 */

package com.fn.dbgen;


import java.util.Map;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class Macros {
    
    public static String processMacroses(String str, Element element, Map arguments) 
                throws DgException 
    {
        int len = str.length();
        StringBuffer sb = new StringBuffer();
        int i = 0;
        while (i < len) {
            char ch = str.charAt(i);
            if (ch == '%') {
                i++;
                if (i >= len)
                    throw new DgException("Invalid macros definition");
                ch = str.charAt(i);
                if (ch == '%')
                    sb.append(ch);
                else {
                    if (Character.isLetter(ch)) {
                        String key = new String() + ch;  // 
                        if (arguments != null) {
                            String sv = (String)arguments.get(key);
                            if (sv != null)
                                sb.append(sv);
                        }
                    } else if (ch == '(') {
                        i++;
                        StringBuffer s = new StringBuffer();
                        while ((i < len) && (str.charAt(i) != ')')) {
                            s.append(str.charAt(i));
                            i++;
                        }
                        if ((i >= len) || (str.charAt(i) != ')'))
                            throw new DgException("Invalid attribute macros");
                        sb.append(element.getAttribute(s.toString()));
                    }
                }
            } else
                sb.append(ch);
            i++;
        }
        return sb.toString();
    }
    
    public static String processFieldList(String str) throws DgException {
        StringBuffer sb = new StringBuffer();
        StringBuffer result = new StringBuffer();
        int len = str.length();
        int i = 0;
        while (i < len) {
            char ch = str.charAt(i);
            if (ch != ',')
                sb.append(ch);
            else {
                String s = sb.toString().trim();
                if (s.length() > 0) {
                    if (result.length() > 0)
                        result.append(", ");
                    result.append('"').append(s).append('"');
                }
                sb.setLength(0);
            }
            i++;
        }
        String s = sb.toString().trim();
        if (s.length() > 0) {
            if (result.length() > 0)
                result.append(", ");
            result.append('"').append(s).append('"');
        }
        return result.toString();
    }
}
